﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace SteamClient
{
    public class CSteamApp
    {
        private int iRet = 0;
        private int m_IsDemo = 0;
        private uint m_DemoOfAppID = 0;
        private string m_State = "";
        private Steam_API.TSteamApp m_SteamApp;
        private Steam_API.TSteamError m_pError = new Steam_API.TSteamError();
        private Dictionary<uint,Steam_API.TSteamAppDependencyInfo> m_Dependencies = new Dictionary<uint,Steam_API.TSteamAppDependencyInfo>();

        public Steam_API.TSteamApp SteamApp
        {
            get { return m_SteamApp; }
            set { m_SteamApp = value; load(); }
        }
        public Steam_API.TSteamError pError
        {
            get { return m_pError; }
        }
        public bool Loading
        {
            get
            {
                int isLoading = 0;
                iRet = Steam_API.SteamIsCacheLoadingEnabled(m_SteamApp.uId, ref isLoading, ref m_pError);
                if (isLoading == 0)
                {
                    return false;
                }
                else
                {
                    return true;
                }
            }
            set
            {
                if (value == true)
                {
                    iRet = Steam_API.SteamStartLoadingCache(m_SteamApp.uId, ref m_pError);
                }
                else
                {
                    iRet = Steam_API.SteamStopLoadingCache(m_SteamApp.uId, ref m_pError);
                }
                if (iRet > 0 && m_pError.eSteamError == 0)
                {
                    Steam_API.TSteamProgress pProgress = new Steam_API.TSteamProgress();
                    while (Steam_API.SteamProcessCall(iRet, ref pProgress, ref m_pError) == 0)
                    {
                        if (m_pError.eSteamError == Steam_API.ESteamError.eSteamErrorBadHandle)
                        {
                            m_pError.eSteamError = 0;
                            break;
                        }
                        Application.DoEvents();
                    }
                }
            }
        }
        public int IsDemo
        {
            get { return m_IsDemo; }
        }
        public uint DemoOfAppID
        {
            get { return m_DemoOfAppID; }
        }
        public string State
        {
            get { return m_State; }
        }
        public Dictionary<uint,Steam_API.TSteamAppDependencyInfo> Dependencies
        {
            get { return m_Dependencies; }
        }
        private void load()
        {
            uint puPropertyValueLength = 0;
            StringBuilder AppState = new StringBuilder(' ', 255);
            iRet = Steam_API.SteamGetAppUserDefinedInfo(m_SteamApp.uId, "state", AppState, 255, ref puPropertyValueLength, ref m_pError);
            if (iRet == 1 && m_pError.eSteamError == 0)
            {
                m_State = AppState.ToString().ToLower();
            }
            iRet = 0; m_pError.eSteamError = 0;

            StringBuilder DemoOfAppID = new StringBuilder(' ', 255);
            m_IsDemo = Steam_API.SteamGetAppUserDefinedInfo(m_SteamApp.uId, "DemoOfAppID", DemoOfAppID, 255, ref puPropertyValueLength, ref m_pError);
            if (iRet == 1 && m_pError.eSteamError == 0)
            {
                m_DemoOfAppID = uint.Parse(DemoOfAppID.ToString());
            }
            iRet = 0; m_pError.eSteamError = 0;
            //
            //for (uint i = 0; i < m_SteamApp.numDependencies; i++)
            //{
            //    Steam_API.TSteamAppDependencyInfo Dependency = new Steam_API.TSteamAppDependencyInfo();
            //    Dependency.szMountName = new String(' ', 255);
            //    iRet = Steam_API.SteamEnumerateAppDependency(m_SteamApp.uId, i, ref Dependency, ref m_pError);
            //    if (iRet == 1 && m_pError.eSteamError == 0)
            //    {
            //        m_Dependencies.Add(i, Dependency);
            //    }
            //    else
            //    {
            //        iRet = 0; m_pError.eSteamError = 0;
            //    }
            //}
            iRet = 0; m_pError.eSteamError = 0;
        }
    }
}
