﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SteamClient
{
    public partial class LaunchForm : Form
    {
        public LaunchForm()
        {
            InitializeComponent();
        }
        internal void load(CSteamApp SApp, uint launchOpt, string cszArgs)
        {
            int iRet = 0;
            Steam_API.TSteamError pError = new Steam_API.TSteamError();
            this.Text = SApp.SteamApp.szName + " - Steam";
            this.label1.Text = "Preparing to launch " + SApp.SteamApp.szName + ".";
            iRet = Steam_API.SteamWaitForAppReadyToLaunch(SApp.SteamApp.uId, ref pError);
            if (iRet != 0 && pError.eSteamError == 0)
            {
                Steam_API.TSteamProgress pProgress = new Steam_API.TSteamProgress();
                while (Steam_API.SteamProcessCall(iRet, ref pProgress, ref pError) == 0)
                {
                    if (pError.eSteamError == Steam_API.ESteamError.eSteamErrorBadHandle)
                    {
                        break;
                    }
                    Application.DoEvents();
                }
            }
            if (pError.eSteamError == 0)
            {
                iRet = Steam_API.SteamLaunchApp(SApp.SteamApp.uId, launchOpt, cszArgs, ref pError);
                if (iRet != 0 && pError.eSteamError == 0)
                {
                    Steam_API.TSteamProgress pProgress = new Steam_API.TSteamProgress();
                    while (Steam_API.SteamProcessCall(iRet, ref pProgress, ref pError) == 0)
                    {
                        if (pError.eSteamError == Steam_API.ESteamError.eSteamErrorBadHandle)
                        {
                            break;
                        }
                        Application.DoEvents();
                    }
                }
            }
            this.Close();
        }

        private void cmdCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}