﻿using System;
using System.ComponentModel;
using System.Reflection;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SteamClient
{
    public partial class LaunchOptionsForm : Form
    {
        private uint Opt_index = 0;
        private CSteamApp App;

        public LaunchOptionsForm()
        {
            InitializeComponent();
        }

        private void cmdLaunch_Click(object sender, EventArgs e)
        {
            LaunchForm frmLaunch = new LaunchForm();
            frmLaunch.Show(this);
            frmLaunch.load(App, Opt_index, "");
        }

        internal void load(CSteamApp SApp)
        {
            int iRet = 0;
            int LocationTop = 8;
            Steam_API.TSteamError pError = new Steam_API.TSteamError();
            Steam_API.TSteamAppLaunchOption AppLaunchOpt;
            App = SApp;
            this.Text = App.SteamApp.szName + " - Steam";
            for (uint i = 0; i < App.SteamApp.uNumLaunchOptions; i++)
            {
                AppLaunchOpt = new Steam_API.TSteamAppLaunchOption();
                AppLaunchOpt.szDesc = new String(' ', 255);
                AppLaunchOpt.szCmdLine = new String(' ', 255);
                AppLaunchOpt.uMaxDescChars = 255;
                AppLaunchOpt.uMaxCmdLineChars = 255;
                iRet = Steam_API.SteamEnumerateAppLaunchOption(App.SteamApp.uId, i, ref AppLaunchOpt, ref pError);
                if (iRet == 1 && pError.eSteamError == 0)
                {
                    RadioButton LaunchOpt = new RadioButton();
                    LaunchOpt.AutoSize = true;
                    LaunchOpt.Location = new System.Drawing.Point(12, LocationTop);
                    LaunchOpt.Name = "LaunchOpt_" + AppLaunchOpt.uIndex.ToString();
                    LaunchOpt.Tag = AppLaunchOpt.uIndex.ToString();
                    LaunchOpt.Size = new System.Drawing.Size((AppLaunchOpt.szDesc.Length * 10), 17);
                    LaunchOpt.TabIndex = 0;
                    LaunchOpt.TabStop = true;
                    LaunchOpt.Text = AppLaunchOpt.szDesc;
                    LaunchOpt.UseVisualStyleBackColor = true;
                    if (i == 0)
                    {
                        LaunchOpt.Checked = true;
                        LaunchOpt.Text = "Launch " + App.SteamApp.szName;
                    }
                    LaunchOpt.CheckedChanged += new EventHandler(this.LaunchOpt_CheckedChanged);
                    this.Controls.Add(LaunchOpt);
                    LocationTop += 23;
                }
            }
            this.Height = LocationTop + 55;
            this.cmdCancel.Top = LocationTop;
            this.cmdLaunch.Top = LocationTop;
        }

        private void LaunchOpt_CheckedChanged(object sender, EventArgs e)
        {
            if (((RadioButton)sender).Checked == true)
            {
                Opt_index = uint.Parse(((RadioButton)sender).Tag.ToString());
            }
        }

        private void cmdCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}