﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Reflection;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;


namespace SteamClient
{
    public partial class PropertiesForm : Form
    {
        public PropertiesForm()
        {
            InitializeComponent();
        }

        internal void load(CSteamApp SApp)
        {
            Steam_API.TSteamError pError = new Steam_API.TSteamError();
            int iHandle = 0;
            /*
            Steam_API.TSteamUpdateStats UpdateStats1 = new Steam_API.TSteamUpdateStats();
            Steam_API.TSteamUpdateStats UpdateStats2 = new Steam_API.TSteamUpdateStats();
            Steam_API.TSteamUpdateStats UpdateStats3 = new Steam_API.TSteamUpdateStats();
            
            
            Steam_API.TSteamProgress pProgress = new Steam_API.TSteamProgress();
            iHandle = Steam_API.SteamGetAppUpdateStats(tApp.AppID, 2, ref UpdateStats1, ref pError);
            if (iHandle > 0 && pError.eSteamError == 0)
            {
                while (Steam_API.SteamProcessCall(iHandle, ref pProgress, ref pError) == 0)
                {
                    if (pError.eSteamError == Steam_API.ESteamError.eSteamErrorBadHandle)
                    {
                        break;
                    }
                    Application.DoEvents();
                }
            }
            iHandle = Steam_API.SteamGetAppUpdateStats(tApp.AppID, 3, ref UpdateStats2, ref pError);
            if (iHandle > 0 && pError.eSteamError == 0)
            {
                while (Steam_API.SteamProcessCall(iHandle, ref pProgress, ref pError) == 0)
                {
                    if (pError.eSteamError == Steam_API.ESteamError.eSteamErrorBadHandle)
                    {
                        break;
                    }
                    Application.DoEvents();
                }
            }
            iHandle = Steam_API.SteamGetAppUpdateStats(tApp.AppID, 4, ref UpdateStats3, ref pError);
            if (iHandle > 0 && pError.eSteamError == 0)
            {
                while (Steam_API.SteamProcessCall(iHandle, ref pProgress, ref pError) == 0)
                {
                    if (pError.eSteamError == Steam_API.ESteamError.eSteamErrorBadHandle)
                    {
                        break;
                    }
                    Application.DoEvents();
                }
            }
            
            int iRet = 0;
            Steam_API.TSteamAppDependencyInfo AppDependency;
            for (uint i = 0; i < tApp.SteamApp.numDependencies; i++)
            {
                AppDependency = new Steam_API.TSteamAppDependencyInfo();
                AppDependency.szMountName = new String(' ', 255);
                iRet = Steam_API.SteamEnumerateAppDependency(tApp.AppID, i, ref AppDependency, ref pError);
                if (iRet == 1 && pError.eSteamError == 0)
                {
                    ListViewItem cItem = new System.Windows.Forms.ListViewItem(new string[] {
                        "[" + AppDependency.AppId.ToString() + "] " +  AppDependency.szMountName,
                        AppDependency.IsRequired.ToString()
                        }, -1);
                    this.AppContentList.Items.Add(cItem);
                }
                pError.eSteamError = 0;
            }
            */

            foreach (Steam_API.TSteamAppDependencyInfo Dependency in SApp.Dependencies.Values)
            {
                ListViewItem cItem = new System.Windows.Forms.ListViewItem(new string[] {
                    "[" + Dependency.AppId.ToString() + "] " +  Dependency.szMountName,
                    Steam_API.GetAppUpdateStats(Dependency.AppId, 1).ToString() + " - " +
                    Steam_API.GetAppUpdateStats(Dependency.AppId, 2).ToString() + " - " +
                    Steam_API.GetAppUpdateStats(Dependency.AppId, 3).ToString() + " - " +
                    Steam_API.GetAppUpdateStats(Dependency.AppId, 4).ToString() + " - " +
                    Steam_API.GetAppUpdateStats(Dependency.AppId, 5).ToString(),    
                    (Dependency.IsRequired == 1 ? "YES" : "NO")
                }, -1);
                this.AppContentList.Items.Add(cItem);
            }

            textBox1.Text = "szName:                        " + SApp.SteamApp.szName + "\x0D\x0A" +
            "uMaxNameChars:                 " + SApp.SteamApp.uMaxNameChars.ToString() + "\x0D\x0A" +
            "szLatestVersionLabel:          " + SApp.SteamApp.szLatestVersionLabel + "\x0D\x0A" +
            "uMaxLatestVersionLabelChars:   " + SApp.SteamApp.uMaxLatestVersionLabelChars.ToString() + "\x0D\x0A" +
            "szCurrentVersionLabel:         " + SApp.SteamApp.szCurrentVersionLabel + "\x0D\x0A" +
            "uMaxCurrentVersionLabelChars:  " + SApp.SteamApp.uMaxCurrentVersionLabelChars.ToString() + "\x0D\x0A" +
            "szCacheFile:                   " + SApp.SteamApp.szCacheFile + "\x0D\x0A" +
            "uMaxCacheFileChars:            " + SApp.SteamApp.uMaxCacheFileChars.ToString() + "\x0D\x0A" +
            "uId:                           " + SApp.SteamApp.uId.ToString() + "\x0D\x0A" +
            "uLatestVersionId:              " + SApp.SteamApp.uLatestVersionId.ToString() + "\x0D\x0A" +
            "uCurrentVersionId:             " + SApp.SteamApp.uCurrentVersionId.ToString() + "\x0D\x0A" +
            "uMinCacheFileSizeMB:           " + SApp.SteamApp.uMinCacheFileSizeMB.ToString() + "\x0D\x0A" +
            "uMaxCacheFileSizeMB:           " + SApp.SteamApp.uMaxCacheFileSizeMB.ToString() + "\x0D\x0A" +
            "uNumLaunchOptions:             " + SApp.SteamApp.uNumLaunchOptions.ToString() + "\x0D\x0A" +
            "uNumIcons:                     " + SApp.SteamApp.uNumIcons.ToString() + "\x0D\x0A" +
            "uNumVersions:                  " + SApp.SteamApp.uNumVersions.ToString() + "\x0D\x0A" +
            "numDependencies:               " + SApp.SteamApp.numDependencies.ToString() + "\x0D\x0A";
        }
    }
}